#ifndef PRETTYICON_H
#define PRETTYICON_H

#include "prettytasks.h"

#include <plasma/widgets/widget.h>
#include <plasma/phase.h>
#include <taskmanager/taskmanager.h>
#include <KDebug>
#include <KIconLoader>

#include <QSizeF>
#include <QGraphicsItem>
#include <QStyleOptionGraphicsItem>
#include <QPainter>
#include <QGraphicsSceneMouseEvent>
#include <QPolygon>
#include <QPen>
#include <QBrush>
#include <QPixmapCache>

using TaskManager::StartupPtr;
using TaskManager::TaskPtr;
 
class PrettyIcon : public Plasma::Widget
{
    Q_OBJECT
    public:
        PrettyIcon(TaskPtr task, int scaledIconSize, int baseIconSize, QGraphicsItem *parent = 0);
        ~PrettyIcon();
        QSizeF sizeHint() const;
        void paintWidget(QPainter *p, const QStyleOptionGraphicsItem *option, QWidget *widget);
        qreal heightForWidth(qreal w) const;
        void hoverMoveEvent(QGraphicsSceneHoverEvent* e);
        void mousePressEvent(QGraphicsSceneMouseEvent *e);
        int getSize();
        
    public slots:
        void scaleTo(int size);
        void taskChanged();
        
    signals:
        void gotHover(PrettyIcon* icon, float across);
        
    private:
        class Private;
        Private* const d;
};

#endif
