#ifndef PRETTYLAYOUT_H
#define PRETTYLAYOUT_H

#include "prettytasks.h"

class PrettyTasks;

#include <QtCore>

#include <plasma/layouts/layoutitem.h>
#include <plasma/layouts/layout.h>
#include <plasma/layouts/layoutanimator.h>

class PrettyLayout : public Plasma::Layout
{
    public:
        explicit PrettyLayout(PrettyTasks* parent);
        virtual ~PrettyLayout();
    
        // reimplemented
        virtual int count() const;
        virtual void addItem(LayoutItem* item);
        virtual void removeItem(LayoutItem* item);
        virtual int indexOf(LayoutItem* item) const;
        virtual LayoutItem* itemAt(int i) const;
        virtual LayoutItem* takeAt(int i);
    
        virtual QSizeF sizeHint() const;
        virtual Qt::Orientations expandingDirections() const;
    
    protected:
        void relayout();
        void releaseManagedItems();
    
    private:
        class Private;
        Private* const d;
        int calculateMaxWidth() const;
};
 
#endif
