#ifndef PRETTYTASKS_H
#define PRETTYTASKS_H

#define MAX_SIZE 128
#define MIN_SIZE 16

#include "prettylayout.h"
#include "prettyicon.h"
#include "ui_prettyTasksConfig.h"

class PrettyLayout;
class PrettyIcon;

#include <cmath>

#include <QtCore>
#include <QPixmapCache>

#include <taskmanager/taskmanager.h>
#include <plasma/applet.h>
#include <KConfigGroup>
#include <KDialog>

using TaskManager::StartupPtr;
using TaskManager::TaskPtr;

class PrettyTasks : public Plasma::Applet
{
    Q_OBJECT
    public:
        // Basic Create/Destroy
        PrettyTasks(QObject *parent, const QVariantList &args);
        ~PrettyTasks();
        void init();
        int calculateSize(int position, int activeItemPosition, float across);
        void setScaledIconSize(int size);
    
    public slots:
        void showConfigurationInterface();
    
    private slots:
        void addWindowTask(TaskPtr task);
        void removeWindowTask(TaskPtr task);
        void loadTasksForDesktop(int desktop);
        void updateIconSizes(PrettyIcon* active, float across);
        void hoverLeaveEvent(QGraphicsSceneHoverEvent* e);
        void writeConfig();
 
    private:
        void reload();
        void reloadConfig();
        class Private;
        Private* const d;
};

#endif
